import PropTypes from 'prop-types';
import React, { ReactNode } from 'react';
export interface CaptionProps {
    /**
     * Children
     */
    children?: ReactNode;
    /**
     * The override API
     */
    overrides?: {
        Caption?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
    };
}
export declare const Caption: {
    ({ children, overrides, ...rest }: CaptionProps): JSX.Element;
    propTypes: {
        /**
         * Children
         */
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * The override API
         */
        overrides: PropTypes.Requireable<PropTypes.InferProps<{
            Caption: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
        }>>;
    };
};
