import PropTypes from 'prop-types';
import React, { ReactNode } from 'react';
export declare const useTableContext: () => any;
export interface TableProps {
    /**
     * Children
     */
    children?: ReactNode;
    /**
     * Striped mode
     */
    striped?: boolean;
    /**
     * Bordered mode
     */
    bordered?: boolean;
    /**
     * The override API
     */
    overrides?: {
        Table?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Caption?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Tbody?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Td?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Tfoot?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Th?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Thead?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
        Tr?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
    };
}
export declare const Table: {
    ({ striped, bordered, children, overrides: componentOverrides, ...rest }: TableProps): JSX.Element;
    propTypes: {
        /**
         * Bordered mode
         */
        bordered: PropTypes.Requireable<boolean>;
        /**
         * Children
         */
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * The override API
         */
        overrides: PropTypes.Requireable<PropTypes.InferProps<{
            Caption: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Table: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Tbody: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Td: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Tfoot: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Th: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Thead: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Tr: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
        }>>;
        /**
         * Striped mode
         */
        striped: PropTypes.Requireable<boolean>;
    };
};
