import PropTypes from 'prop-types';
import React, { ReactNode } from 'react';
export interface TdProps {
    /**
     * Children
     */
    children?: ReactNode;
    /**
     * Whether or not the cell is highlighted
     */
    highlighted?: boolean;
    /**
     * Whether or not the start of the highlighted cells
     */
    highlightStart?: boolean;
    /**
     * Bordered mode
     */
    bordered?: boolean;
    /**
     * The override API
     */
    overrides?: {
        Td?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
    };
}
export declare const Td: {
    ({ highlighted, highlightStart, bordered, children, overrides, ...rest }: TdProps): JSX.Element;
    propTypes: {
        /**
         * Bordered mode
         */
        bordered: PropTypes.Requireable<boolean>;
        /**
         * Children
         */
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * Whether or not the cell is highlighted
         */
        highlighted: PropTypes.Requireable<boolean>;
        /**
         * Whether or not the start of the highlighted cells
         */
        highlightStart: PropTypes.Requireable<boolean>;
        /**
         * The override API
         */
        overrides: PropTypes.Requireable<PropTypes.InferProps<{
            Td: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
        }>>;
    };
};
