import PropTypes from 'prop-types';
import React, { ReactNode } from 'react';
export interface TfootProps {
    /**
     * Children
     */
    children?: ReactNode;
    /**
     * Whether or not there should border styling
     */
    bordered?: boolean;
    /**
     * The override API
     */
    overrides?: {
        Tfoot?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
    };
}
export declare const Tfoot: {
    ({ bordered, children, overrides, ...rest }: TfootProps): JSX.Element;
    propTypes: {
        /**
         * Whether or not there should border styling
         */
        bordered: PropTypes.Requireable<boolean>;
        /**
         * Children
         */
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * The override API
         */
        overrides: PropTypes.Requireable<PropTypes.InferProps<{
            Tfoot: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
        }>>;
    };
};
