import PropTypes from 'prop-types';
import React, { ReactNode } from 'react';
export interface TrProps {
    /**
     * striped
     */
    striped?: any;
    /**
     * Children
     */
    children?: ReactNode;
    /**
     * Highlighted mode
     */
    highlighted?: boolean | unknown[];
    /**
     * The override API
     */
    overrides?: {
        Tr?: {
            styles?: (...args: unknown[]) => unknown;
            component?: React.ElementType;
            attributes?: (...args: unknown[]) => unknown;
        };
    };
}
export declare const Tr: {
    ({ striped, highlighted, children, overrides, ...rest }: TrProps): JSX.Element;
    propTypes: {
        /**
         * Children
         */
        children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        /**
         * Highlighted mode
         */
        highlighted: PropTypes.Requireable<NonNullable<boolean | any[] | null | undefined>>;
        /**
         * The override API
         */
        overrides: PropTypes.Requireable<PropTypes.InferProps<{
            Tr: PropTypes.Requireable<PropTypes.InferProps<{
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                styles: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
        }>>;
        /**
         * striped
         */
        striped: PropTypes.Requireable<any>;
    };
};
